Do not map minThrust to 0% throttle
08/27/2017 12:09 PM - psycho_zs

Status: New

Severity: Low

Assignee:

Category: Gameplay

Target version:

Version: 1.3.0 Language: English (US)
Platform: Linux, OSX, PS4, Windows, XBoxOne Mod Related: No
Expansion: Core Game

Description

Not directly related to 1.3.1, but version bump might be a good occasion for this.

Currently in ModuleEngines and ModuleEnginesFX minThrust is always mapped to 0% throttle. It is hard to simulate poorly
throttlable engines with this behavior.

Instead always map OkN thrust to 0% throttle and have the engines flame-out if thrust provided by current throttle is below minThrust.

Additionally, a tweakable can be added (under advanced tweakables) to engine parts to select behavior when 0 < currentThrust <
minThrust: either flame-out or continue burning on minThrust.

History

#1 - 10/05/2017 03:39 PM - Squelch

- Project changed from KSP Pre-Release to Kerbal Space Program
- Category changed from Gameplay to 291

- Version changed from Build 01836 to 1.3.0

Thanks for the feedback. As you rightly point out, it is not 1.3.1 specific. Moved to main tracker.

#2 - 10/05/2017 03:46 PM - psycho_zs

- Description updated

#3 - 12/27/2017 08:05 AM - psycho_zs

- Description updated

#4 - 01/10/2018 01:07 PM - linuxgurugamer

Oh, | think | understand, this is related to the throttle settings. NM, he is correct
But, this applies to ModuleEngines as well as ModuleEnginesFX, | think

#5 - 01/10/2018 02:18 PM - psycho_zs

- Description updated

#6 - 01/10/2018 11:21 PM - linuxgurugamer

| would suggest this be made an option. Some people, including myself, would prefer that the entire range of the throttle on screen be the available
range of the thrust, the way it is now

#7 - 01/12/2018 10:16 AM - psycho_zs
Things will get messy either way when engines with different throttle depth are used simultaneously.

Combinations of things can be reduced down to three advanced tweakables:

e shutdown engines when throttle = 0
e shutdown engine when it's current thrust < minThrust
e throttle mapping: stretched or proportinal

Out of 12 (2*2*3) possible variants, only 7 make sense:

Proportional, shutdown under minThrust:

Enginel: 0 |maxThrust
Engine?2: 000000000000 |minThrust |maxThrust
Engine3: 00000000000000000000000000 |minThrust—-——--—-—- |maxThrust
Throttle: 0lnot_0 | | 1100

Proportional, shutdown at O:

Enginel: 0 |maxThrust
Engine?2: Ommmmmmmmmmm | minThrust |maxThrust
Engine3: Ommmmmmmmmmmmmmmmmmmmmmmnunn |minThrust—————-— |maxThrust
Throttle: 0lnot_0 |100

Proportional, no shutdown (## Current model in KSP ##):

Enginel: 0 |maxThrust
Engine?2: mmmmmmmmmmmmnm | minThrust |maxThrust
Engine3: mmmmmmmmmmmmmmmuonnmmmmmmm | minThrust—————— |maxThrust
Throttle: 0lnot_0 |100

Stretched proportionally to deepest throttle, no shutdown:
(Enginel removed, otherwise it would be the same as proportional)

Engine?2: |minThrust |maxThrust
Engine3: mmmmmmmmmmmmmmmmmmmomm | minThrust-—————————- |maxThrust
Throttle: 0lnot_0 |100

Stretched proportionally to deepest throttle, shutdown at 0
(Enginel removed, otherwise it would be the same as proportional)

Engine?2: 0 |minThrust |maxThrust
Engine3: Ommmmmmmmmmmmmmmmmmmm | minThrust—-—————————— |maxThrust
Throttle: 0lnot_0 |100

Stretched full, no shutdown:

Enginel: 0 |maxThrust
Engine?2: Q=== |l RTRETgE—————————— |maxThrust
Engine3: e s e s s e | R TREREE————————————= |maxThrust
Throttle: 0lnot_0 [|100

Stretched full, shutdown at O0O:

Enginel: 0 |maxThrust
Engine?2: Q=== O|lminThrust-——————-———- |maxThrust
Engine3: e s e s s e B |l TREg == |maxThrust
Throttle: 0lnot_0 [|100

Let's screen less desired models...

Continuing burning when throttle is at 0 might not make sense gameplay-wise.

Proportional stretching utilizes the throttle control range more fully, but may be unpredictable when the set of currently active engines changes.
Option to Flame out under minThrottle might not fit well globally, so apply it for engine individually in editor (defaulting to continue burning)

This lefts us with 3 global models:

Proportional:

Enginel: 0 |maxThrust
Engine?2: Ommmmmmmmmmm | minThrust |maxThrust
Engine3: Ommmmmmmmmmmmmmmmmmmmmmmnunn |minThrust—————-— |maxThrust
Throttle: 0lnot_0 |100

Stretched proportionally to deepest throttle:
(Enginel removed, otherwise it would be the same as proportional)

Engine?2: 0 |minThrust |maxThrust
Engine3: Ommmmmmmmmmmmmmmmmmmm | minThrust-—————————— |maxThrust
Throttle: 0lnot_0 |100

Stretched full:

Enginel: 0 |maxThrust
Engine?2: Q=== O|lminThrust-——————-———- |maxThrust
Engine3: e s e s s e B |l TREg == |maxThrust
Throttle: 0lnot_0 [|100

+ an option at part level to flameout below minThrust
#8 - 01/16/2018 01:13 PM - psycho_zs

Another possibility is to move all throttle advanced tweaks to part level.
Imagine these options in engine's menu in VAB:

Under throttle: flameout/continue

Map min. thrust to:

[-==——- O—————————————————————— 1 30% throttle
Map max. thrust to:

[ o] 100% throttle
Over throttle: flameout/continue

With advanced tweakables disabled, just rely on some default values modeled after some of the variants mentioned in previous comments. With
advanced tweakables enabled you could actually create an engine cluster which fires different sets of engines on different thrust levels while at
certain throttle.

#9 - 04/05/2018 11:35 AM - psycho_zs

- Expansion Core Game added

Alternative idea: Add throttleTrhustCurve to ModuleEngines*
like:

throttleThrustCurve
{
key = 0 0
key =1 75
key 100 100
